Name:           cegui
Version:        0.4.1
Release:        10%{?dist}
Summary:        Free library providing windowing and widgets for graphics APIs / engines

Group:          System Environment/Libraries
License:        LGPL
URL:            http://www.cegui.org.uk/
Source0:        http://download.sourceforge.net/crayzedsgui/%{name}_mk2-source-%{version}.tar.bz2
Patch0:         cegui_mk2-0.4.1-pcre.patch
Patch1:         cegui_mk2-0.4.1-tolua++.patch
Patch2:         cegui_mk2-0.4.1-fixtinyxml.patch
Patch3:         cegui_mk2-0.4.1-64bit.patch
Patch4:         cegui_mk2-0.4.1-useverso.patch
Patch5:         cegui_mk2-0.4.1-fixheader.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:  gawk
BuildRequires:  freetype-devel > 2.0.0
BuildRequires:  DevIL-devel
BuildRequires:  pcre-devel
BuildRequires:  pkgconfig >= 0.9.0
BuildRequires:  libGLU-devel
BuildRequires:  tolua++-devel
Provides:       CEGUI = %{version}-%{release}
Provides:       cegui_mk2 = %{version}-%{release}

%description
Crazy Eddie's GUI System is a free library providing windowing and widgets for
graphics APIs / engines where such functionality is not natively available, or
severely lacking. The library is object orientated, written in C++, and
targeted at games developers who should be spending their time creating great
games, not building GUI sub-systems!

%package devel
Summary:        Development files for cegui
Group:          Development/Libraries
Requires:       cegui = %{version}-%{release}
Requires:       pkgconfig
Requires:       libGLU-devel
Provides:       CEGUI-devel = %{version}-%{release}
Provides:       cegui_mk2-devel = %{version}-%{release}

%description devel
Development files for cegui


%package devel-doc
Summary:        API documentation for cegui
Group:          Documentation
Requires:       cegui-devel = %{version}-%{release}
Provides:       CEGUI-devel-doc = %{version}-%{release}
Provides:       cegui_mk2-devel-doc = %{version}-%{release}
Provides:       cegui-devel-docs = %{version}-%{release}
Obsoletes:      cegui-devel-docs

%description devel-doc
API and Falagard skinning documentation for cegui


%prep
%setup -q -n %{name}_mk2
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
#Delete bundled pcre to avoid any accidental building against it.
rm -rf src/pcre
#Delete bundled lua / tolua++ to avoid any accidental building against it.
rm -rf ScriptingModules/CEGUILua/lua_and_tolua++
#Fix documentation link in html file
sed -i 's/documentation\/api_reference/api_reference/' ReadMe.html


%build
#Regenerate bindings with system tolua++. The reason for the change directory
#(pushd) before calling tolua++, is because tolua++ only looks in the current
#directory for the files depended on my CEGUI.pkg. If a full path is specified,
#it fails.
pushd ScriptingModules/CEGUILua/LuaScriptModule/package/
tolua++ -o ../src/lua_CEGUI.cpp CEGUI.pkg
popd
%configure --disable-irrlicht-renderer --disable-samples --with-pic --without-xerces-c
make %{?_smp_mflags}


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}
rm -f %{buildroot}%{_libdir}/*.la %{buildroot}%{_libdir}/*.a
rm -rf %{buildroot}%{_includedir}/CEGUI/renderers/IrrlichtRenderer
#Cleanup CVS stuff in the documentation area before the %%doc section
rm -rf documentation/CVS documentation/api_reference/CVS documentation/api_reference/keepme documentation/api_reference/*.md5


%clean
rm -rf %{buildroot}


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig


%files
%defattr(-,root,root,-)
%{_libdir}/libCEGUIBase.so.0
%{_libdir}/libCEGUIBase.so.0.0.0
%{_libdir}/libCEGUIFalagardBase.so.0
%{_libdir}/libCEGUIFalagardBase.so.0.0.0
%{_libdir}/libCEGUILuaScriptModule.so.0
%{_libdir}/libCEGUILuaScriptModule.so.0.0.0
%{_libdir}/libCEGUIOpenGLRenderer.so.0
%{_libdir}/libCEGUIOpenGLRenderer.so.0.0.0
%{_libdir}/libCEGUITaharezLook.so.0
%{_libdir}/libCEGUITaharezLook.so.0.0.0
%{_libdir}/libCEGUIWindowsLook.so.0
%{_libdir}/libCEGUIWindowsLook.so.0.0.0
#The pristine sources generate this library, which is not needed when building
#against the system tolua++/lua.
##%%{_libdir}/libCEGUIluatoluapp.so.0
##%%{_libdir}/libCEGUIluatoluapp.so.0.0.0
%doc AUTHORS COPYING README TinyXML-License

%files devel
%defattr(-,root,root,-)
%{_libdir}/libCEGUIBase.so
%{_libdir}/libCEGUIFalagardBase.so
%{_libdir}/libCEGUILuaScriptModule.so
%{_libdir}/libCEGUIOpenGLRenderer.so
%{_libdir}/libCEGUITaharezLook.so
%{_libdir}/libCEGUIWindowsLook.so
#The pristine sources generate this library , which is not needed when building
#against the system tolua++/lua.
#%%{_libdir}/libCEGUIluatoluapp.so
%{_libdir}/pkgconfig/CEGUI-OPENGL.pc
%{_libdir}/pkgconfig/CEGUI.pc
%{_includedir}/CEGUI

%files devel-doc
%doc documentation/Falagard_Skinning_Docs.pdf documentation/api_reference


%changelog
* Sat Aug 05 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-10%{?dist}
- Header fix for g++ v4.1+

* Tue Jul 18 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-9%{?dist}
- Use versioned .so for dlopen()

* Sun Jun 11 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-8%{?dist}
- Updated --rpath fixes again
- Package devel-docs renamed to devel-doc as per 'new' guidelines

* Sat Jun 10 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-7.iss
- Updated --rpath fixes

* Fri Jun 09 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-6.iss
- Added patch courtesy of Hans de Goede fixing TinyXML usage
- Added patch courtest of Hans de Goede fixing 64bit issues
- Updated --rpath fixes
- Trivial correction for pkgconfig BR, should be >= really and not >

* Wed Jun 07 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-5.iss
- Removed IrrlichtRender headers as we don't support it (yet - anyway)
- Removed usage of --rpath during build process
- libtool dropped as a BR (no longer needed due to --rpath fix)
- Moved rebuilding of C++ bindings to %%build section

* Mon Jun 05 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-4.iss
- Added a tentative patch for building with the system tolua++/lua
- Added tolua++-devel as a buildrequire
- Rebuild the C++ bindings using the system tolua++

* Sun May 28 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-3.iss
- Added patch courtesy of Hans de Goede to force compilation against the system
  pcre libs instead of the bundled pcre.
- Added pcre-devel to buildrequires
- Replace xorg-x11-devel with libGLU-devel
- Removed PCRE-LICENSE from doc as it's now compiled against system pcre
- Specified version for pkgconfig buildrequires
- Replaced source URL with primary sf site, rather than a mirror
- Don't use bootstrap
- Added cegui_mk2 provides
- Removed superfluous documentation from devel package

* Sat May 27 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-2.iss
- Use %%{?dist} for most recent changelog entry - avoids incoherent changelog
  versions if %%{?dist} macro is missing or different.
- Added %%{version}-%%{release} to provides field
- Replaced %%{__sed} with sed

* Sun May 21 2006 Ian Chapman <packages@amiga-hardware.com> 0.4.1-1.iss
- Initial Release
